#gameUIContainer, #areaContainer, #gameShopContainer, #gamePauseContainer {
    position: absolute;
    width: 100dvw;
    height: 100dvh;
    display: flex;
    justify-content: center;
    align-items: center;
    user-select: none;
}

#gamePauseContainer {
    background-color: rgb(0,0,0,0);
    backdrop-filter: blur(0px);
    z-index: 11;
    pointer-events: none;
    transition: 
        backdrop-filter ease-in-out 500ms,
        background-color ease-in-out 500ms;
}

#gamePauseTitle {
    position: absolute;
    bottom: 250px;
    font-size: 1.5em;
    font-weight: 700;
    transition: bottom ease-in-out 500ms;
}

#gamePause {
    position: absolute;
    bottom: 0px;
    left: 0px;
    width: calc(100dvw - 10px);
    height: 0px;
    padding: 0px;
    border-top: 0px solid white;
    background-color: rgb(0,0,0,0.5);
    backdrop-filter: blur(5px);
    transition: 
        height ease-in-out 500ms, 
        border-top ease-in-out 500ms,
        padding ease-in-out 500ms;
}

.gamePauseMenu {
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    gap: 5px;
    position: absolute;
    transition: opacity ease-in-out 250ms;
}

.gamePauseMenu button {
    width: 150px;
}

#gameShopContainer {
    z-index: 4;
    display: none;
    flex-direction: column;
    gap: 25px;
}

#gameShop {
    background-color: rgb(0,0,0,0.5);
    backdrop-filter: blur(10px);
    outline: 2px solid white;
    padding: 5px;
    display: flex;
    gap: 5px;
}

#gameShopTitle {
    font-size: 1.25em;
    font-weight: 700;
}

#gameShopUpgradesContainer {
    display: flex;
    flex-direction: column;
    gap: 5px;
    width: fit-content;
}

.gameShopSection {
    width: fit-content;
    min-width: 350px;
    padding: 24px 4px 4px 4px;
    border: 2px solid grey;
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    position: relative;
    gap: 5px;
}

#gameShopUpgrades {
    display: flex;
    gap: 5px;
}

.gameShopHeader {
    position: absolute;
    top: 0px;
    left: 0;
    width: 100%;
    text-align: center;
    letter-spacing: 5px;
    color: gray;
}

.shopItem {
    padding: 5px;
    width: 75px;
    height: 75px;
    border: 2px solid rgb(25,25,25);
    display: flex;
    justify-content: center;
    align-items: center;
    position: relative;
    scale: 0;
    margin-bottom: 10px;
    outline: 0px solid white;
    transition: outline 250ms ease-in-out;
}

.shopItem img {
    pointer-events: none;
}

@keyframes shopItemIn {
    from {
        scale: 0;
        box-shadow: inset 0px 0px 0px 32.5px white;
    }
    50% {
        scale: 1;
        /* box-shadow: inset 0px 0px 0px 32.5px white; */
    }
    to {
        scale: 1;
        /* box-shadow: inset 0px 0px 0px 0px grey; */
    }
}

@keyframes mythicBorder {
    from {
        border: 2px solid rgb(100, 255, 255);
        box-shadow: 0px 0px 10px rgb(100, 255, 255, 0.5);
    }
    50% {
        border: 2px solid rgb(255, 100, 255);
        box-shadow: 0px 0px 10px rgb(255, 100, 255, 0.5);
    }
    to {
        border: 2px solid rgb(100, 255, 255);
        box-shadow: 0px 0px 10px rgb(100, 255, 255, 0.5);
    }
}

@keyframes mythicGlow {
    from {
        filter: drop-shadow(0px 0px 10px rgb(100, 255, 255, 0.5))
    }
    50% {
        filter: drop-shadow(0px 0px 10px rgb(255, 100, 255, 0.5))
    }
    to {
        filter: drop-shadow(0px 0px 10px rgb(100, 255, 255, 0.5))
    }
}

.shopItemPrice {
    position: absolute;
    width: 100%;
    display: flex;
    justify-content: center;
    bottom: -10px;
    left: 0px;
}

.shopItemPrice span, .shopElixirTier span {
    background-color: black;
    color: rgb(255,255,100);
    font-weight: 700;
    height: 20px;
    display: flex;
    justify-content: center;
    align-items: center;
    padding: 0px 5px;
    text-align: center;
    line-height: 1;
}

.shopElixirTier span {
    font-family: monospace;
    color: aqua;
}

.shopElixirTier {
    display: flex;
    justify-content: center;
    position: absolute;
    top: -10px;
    height: 20px;
}

.shopItem img {
    width: 48px;
    height: 48px;
    transition: scale var(--bouncy) 250ms;
}

.shopItem:active img {
    scale: 0.9;
}

.shopItem:hover {
    background-color: rgb(25,25,25);
    cursor: pointer;
}

#gameShopUpgradesButtons {
    display: flex;
    gap: 5px;
}

#gameShopTabs {
    display: flex;
    justify-content: center;
    gap: 9px;
}

.gameShopTab {
    padding: 5px;
    outline: 2px solid grey;
    display: flex;
    gap: 5px;
}

.gameShopTabItem {
    padding: 5px;
    border: 2px solid rgb(255,255,255,0.25);
    width: 36px;
    height: 36px;
    display: flex;
    justify-content: center;
    align-items: center;
    position: relative;
}

.gameShopElixirsTabTier {
    position: absolute;
    bottom: -5px;
    height: 10px;
    display: flex;
    justify-content: center;
    align-items: center;
    line-height: 1;
    font-size: 0.75em;
    font-family: monospace;
}

.gameShopElixirsTabTier span {
    background-color: black;
    padding: 0px 5px;
    color: aqua;
    font-weight: bold;
}

#continueButton {
    padding: 5px 25px;
    background-color: rgb(0,0,0,0.75);
    backdrop-filter: blur(10px);
}

#continueButton:hover {
    background-color: white;
}

#rerollPrice {
    font-weight: 700;
    color: rgb(255,255,100);
}

#gameShopUpgradesButtons button:hover span {
    color: black;
}

#bankBalance {
    font-size: 1.25em;
    font-weight: 700;
}

#bankButtons {
    display: flex;
    flex-direction: column;
    gap: 5px;
}

#bankButtons button {
    width: 100%;
}

#bankBreakChance {
    font-size: 0.75em;
    color: grey;
}

#shopChest {
    cursor: pointer;
}






#gameOverContainer {
    position: fixed;
    left: 0;
    top: 0;
    width: 100dvw;
    height: 100dvh;
    display: flex;
    justify-content: center;
    align-items: center;
    z-index: 10;
}

#gameOver {
    padding: 5px;
    outline: 2px solid white;
    background-color: rgba(0,0,0);
}

.gameOverRow {
    display: flex;
    gap: 5px;
    width: 400px;
    margin-bottom: 5px;
}

.gameOverBox {
    border: 1px solid grey;
    position: relative;
    padding: 10px;
    width: 100%;
    display: flex;
    justify-content: center;
}

.gameOverBoxTitle {
    position: absolute;
    top: -5px;
    left: 5px;
    background-color: black;
    height: 10px;
    display: flex;
    align-items: center;
    padding: 0px 5px;
    font-size: 0.75em;
    font-weight: 900;
    color: grey;
    white-space: nowrap;
}

#go-score {
    font-family: 'Roboto Mono', monospace;
    font-size: 2em;
    font-weight: 700;
}

#gameRestartContainer {
    position: fixed;
    bottom: 25px;
    left: 0;
    width: 100dvw;
    display: flex;
    align-items: center;
    flex-direction: column;
    gap: 10px;
    font-size: 1.5em;
    font-weight: 700;
    z-index: 10;
    filter: drop-shadow(0px 0px 5px black);
    translate: 0px 100px;
    transition: translate ease-in-out 250ms;
}

#gameRestartBar {
    width: 500px;
    height: 10px;
    outline: 1px solid white;
    border-radius: 5px;
    background-color: rgb(0,0,0,0.75);
    display: flex;
    justify-content: center;
}

#gameInnerRestartBar {
    height: 100%;
    width: 50%;
    border-radius: 5px;
    background-color: white;
    transition: width linear 20ms;
}

#gameUIContainer {
    z-index: 2;
    pointer-events: none;
    overflow: hidden;
}

#gameSandboxContainer {
    position: absolute;
    right: 0px;
    height: 100dvh;
    display: flex;
    align-items: center;
    z-index: 3;
}

#gameSandbox {
    padding: 5px;
    background-color: rgb(0,0,0,0.5);
    backdrop-filter: blur(10px);
    outline: 2px solid white;
    display: flex;
    flex-direction: column;
    width: 350px;
}

#gameSandboxTabs {
    display: flex;
    justify-content: center;
    flex-wrap: wrap;
    gap: 5px;
    border-bottom: 2px solid grey;
    padding-bottom: 5px;
}

#gameInnerSandbox {
    height: 500px;
    overflow-y: auto;
    overflow-x: hidden;
}

#gameSandboxTabs button {
    width: 110px;
}

#sandboxMenu-upgrades, #sandboxMenu-enemies, #sandboxMenu-powerItems, #sandboxMenu-elixirs {
    display: flex;
    flex-wrap: wrap;
    justify-content: center;
    position: relative;
    gap: 5px;
    margin-top: 5px;
}

.sandboxUpgrade {
    padding: 5px;
    border: 2px solid white;
    width: 35px;
    height: 35px;
    display: flex;
    justify-content: center;
    align-items: center;
    cursor: pointer;
    user-select: none;
}

.sandboxUpgrade img {
    width: 32px;
    height: 32px;
}

#sandboxMenu-stats {
    display: flex;
    flex-direction: column;
    max-height: 100%;
}

.sandboxStatsSectionHeader {
    display: flex;
    gap: 5px;
    align-items: center;
    white-space: nowrap;
    color: rgb(255,255,255,0.25);
    font-weight: 700;
    font-size: 0.75em;
    user-select: none;
    cursor: pointer;
}

.sandboxStatContainer {
    display: flex;
    margin-bottom: 5px;
    gap: 5px;
    justify-content: space-between;
    align-items: center;
    white-space: nowrap;
}

.sandboxStatContainer input {
    width: 100px;
    height: 20px;
    outline: none;
    border: 2px solid white;
}

.sandboxStatContainer hr {
    width: 100%;
    border: none;
    border-top: 2px dotted white;
    height: 0px;
}

.sandboxStatContainer input[type="checkbox"] {
    height: 25px;
    width: unset;
    margin-right: 25px;
    cursor: pointer;
}

#sandboxMenu-tools {
    display: flex;
    align-items: center;
    flex-direction: column;
    gap: 5px;
}

#sandboxMenu-tools button {
    width: 200px;
}

.numInput {
    display: flex;    
}

.numInput button, .numInput input {
    width: 100px !important;
    outline: none;
    border: 2px solid white;
}

.numInput input {
    text-align: right;
}








#areaContainer {
    z-index: 1;
}

#noticeContainer {
    position: absolute;
    top: 10px;
    left: 0px;
    width: 100%;
    display: flex;
    align-items: center;
    pointer-events: none;
    flex-direction: column;
    z-index: 4;
}

.areaNotice {
    height: 20px;
    display: flex;
    justify-content: center;
    align-items: center;
    gap: 25px;
    font-weight: 700;
    animation: noticeIn 500ms ease-out 1 forwards;
}

@keyframes noticeIn {
    from {
        height: 0px;
        opacity: 0;
    }
    50% {
        height: 20px;
    }
    to {
        opacity: 1;
    }
}

@keyframes noticeOut {
    50% {
        height: 20px;
        opacity: 0;
    }
    to {
        height: 0px;
        opacity: 0;
    }
}

#crosshair {
    position: absolute;
    height: 1px;
    width: 1px;
    z-index: 5;
    pointer-events: none;
    z-index: 9;
}

#innerCrosshair {
    position: relative;
    display: flex;
    justify-content: center;
    align-items: center;
    /* outline: 1px solid white; */
    aspect-ratio: 1 / 1;
    translate: -50% -50%;
    min-height: 15px;
    min-width: 15px;
}

.crosshairLineV {
    height: 10px;
    width: 2px;
    backdrop-filter: invert();
    position: absolute;
}

.crosshairLineH {
    height: 2px;
    width: 10px;
    backdrop-filter: invert();
    position: absolute;
}

#cursorBars {
    display: flex;
    flex-direction: column;
    position: absolute;
    z-index: 9;
    opacity: 0.75;
    border: 1px solid white;
}

.cursorBar {
    height: 2px;
    width: 25px;
    overflow: hidden;
}

.cursorBar div {
    height: 100%;
    background-color: white;
    transition: width linear 25ms;
}

#tutorialist {
    position: absolute;
    width: 54px;
    height: 54px;
    z-index: 8;
    /* background-image: url(graphics/characters/tutorialistPortrait.png); */
    /* background-size: 54px 54px; */
    animation: tutorialistFloatX 5s ease-in-out -3.14156767ms infinite forwards, tutorialistFloatY 5.5324234s ease-in-out 0ms infinite forwards;
    transition: left cubic-bezier(.5,0,.5,1) 1s, top cubic-bezier(.5,0,.5,1) 1s;
}

.tutorialistShadow {
    position: absolute;
    background-image: url(graphics/characters/tutorialistPortrait.png);
    background-size: 54px 54px;
    z-index: -1;
    animation: tutorialistShadow 1s linear forwards;
}

@keyframes tutorialistFloatX {
    from {
        translate: -5px 0px;
    }
    50% {
        translate: 5px 0px;
    }
    to {
        translate: -5px 0px;
    }
}

@keyframes tutorialistFloatY {
    from {
        transform: translateY(-5px);
    }
    50% {
        transform: translateY(5px);
    }
    to {
        transform: translateY(-5px);
    }
}

@keyframes tutorialistShadow {
    to {
        translate: var(--shadowX) var(--shadowY);
        opacity: 0;
    }
}

#tutorialistDialogueContainer {
    padding: 5px;
    outline: 2px solid white;
    box-shadow: 0px 0px 0px 4px black;
    background-color: rgb(0,0,0,0.5);
    backdrop-filter: blur(10px);
    position: absolute;
    z-index: 8;
    max-width: 300px;
    display: flex;
    flex-direction: column;
    align-items: center;
    gap: 5px;
    transition: left cubic-bezier(.5,0,.5,1) 1s, top cubic-bezier(.5,0,.5,1) 1s;
}

#tutorialGoal {
    display: flex;
    flex-direction: column;
    gap: 5px;
    width: 100%;
    margin-top: 10px;
}

#tutorialGoal section {
    display: flex;
    justify-content: space-between;
    gap: 10px;
}

#tutorialGoalProgressBar {
    width: calc(100% - 2px);
    border: 1px solid white;
    height: 10px;
}

#tutorialGoalProgress {
    width: 50%;
    height: 100%;
    background-color: white;
    transition: width cubic-bezier(0,1,.5,1) 500ms;
}

#gameTopLeftContainer {
    position: absolute;
    top: 25px;
    left: 25px;
    display: flex;
    flex-direction: column;
    z-index: 2;
}

#gameTopLeft {
    display: flex;
    gap: 25px;
    align-items: center;
}

#powerItemContainer {
    display: flex;
    flex-direction: column;
    align-items: center;
}

#powerItem {
    width: 48px;
}

@keyframes powerItemPulse {
    from {
        scale: 1.25;
    }
}

@keyframes blunt {
    to {
        opacity: 0;
        /* filter: blur(100px); */
    }
}

#powerItemContainer span {
    height: 0px;
}

#gameStatusBarsContainer {
    display: flex;
    font-weight: 700;
    flex-direction: column;
    width: 300px;
    transform: skewX(-10deg);
}

.statusBar {
    border: 2px solid white;
    width: 250px;
    min-width: 250px;
    height: 10px;
    overflow: hidden;
    position: relative;
    background-color: black;
}

.innerStatusBar {
    height: 100%;
    width: 0;
    transition: width cubic-bezier(0,1,.5,1) 0.5s;
}

#healthBarNum {
    display: flex;
    white-space: nowrap;
}

#lowerPowerBar {
    position: absolute;
    top: 0;
    border-right: 1px solid red;
}

#gameMoneyCount {
    font-size: 1.25em;
    font-weight: 700;
    color: rgb(255,255,100);
    width: fit-content;
    /* animation: moneyPulse 500ms ease-out 1 forwards; */
}

@keyframes moneyPulse {
    from {
        scale: var(--moneyScale);
        rotate: var(--moneyRot);
    }
}

#statusEffectContainer {
    display: flex;
    gap: 5px;
}

.statusEffect {
    border-radius: 50%;
    border: 2px solid white;
    width: 48px;
    height: 48px;
    display: flex;
    justify-content: center;
    align-items: center;
    overflow: hidden;
    position: relative;
}

.statusEffect img {
    width: 100%;
    height: 100%;
}

.statsEffectOverlay {
    position: absolute;
    top: 0;
    bottom: 0;
    width: 100%;
    height: 50%;
    backdrop-filter: grayscale();
}

#gameBossbarContainer {
    position: absolute;
    top: 4px;
    left: 0;
    width: 100dvw;
    height: 100px;
    display: flex;
    align-items: center;
    flex-direction: column;
}

.gameBossbar {
    width: 500px;
    height: 30px;
    min-height: 5px;
    background-color: black;
    outline: 2px solid white;
    border: 2px solid black;
    margin: 4px;
    box-shadow: 0px 0px 0px 4px black;
    font-weight: 700;
    z-index: 2;
    position: relative;
    overflow: hidden;
    animation: gameBossbarIn 500ms cubic-bezier(0,1,.5,1) 1 forwards;
}

@keyframes gameBossbarIn {
    from {
        scale: 0 1;
    }
}

.gameBossbar span {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    font-size: 1.25em;
    z-index: 2;
    filter: drop-shadow(0px 0px 3px black);
}

.gameBossbar div {
    width: 50%;
    height: 100%;
    background-color: grey;
    transition: width cubic-bezier(0,1,.5,1) 0.5s;
    box-shadow: inset 0px -15px 0px 0px rgb(0,0,0,0.1), inset 0px 1px 0px 0px rgb(255,255,255,0.5);
}

@keyframes bossbarPulse {
    from {
        filter: brightness(150%);
    }
}

.gameStatSectionName {
    font-size: 1.1em;
    font-weight: 700;
}

#gameStatsContainer {
    position: absolute;
    display: flex;
    flex-direction: column;
    justify-content: center;
    height: 100%;
    left: 25px;
    opacity: 0.25;
    font-size: 0.5em;
}

.gameStatContainer {
    line-height: 1;
    margin-bottom: 10px;
}

.gameStatChange {
    opacity: 0;
    transition: opacity ease-in-out 500ms;
}




#gameBottomLeftContainer {
    position: absolute;
    bottom: 25px;
    left: 25px;
    display: flex;
    flex-direction: column;
    gap: 10px;
}


#consumablesContainer {
    display: flex;
    flex-direction: column;
    gap: 5px;
}

.gameConsumable {
    width: 64px;
}

#gameAmmoContainer {
    transform: skewX(-10deg);
}

#gameAmmo {
    display: flex;
    gap: 5px;
    font-size: 1.5em;
    font-weight: 700;
    height: 35px;
}

#gameAmmoBar {
    width: 100%;
    height: 5px;
    overflow: hidden;
    background-color: rgb(255,255,255,0.5);
}

#gameInnerAmmoBar {
    height: 100%;
    width: 50%;
    background-color: white;
}

#gameAmmoCount {
    font-family: 'Roboto Mono', monospace;
}

#debugButtons {
    position: absolute;
    bottom: 10px;
    width: 100%;
    display: flex;
    justify-content: center;
    gap: 10px;
    z-index: 100000;
    pointer-events: all;
}

#debugButtons {
    pointer-events: all;
}


#gameDebug {
    position: absolute;
    bottom: 200px;
    left: 5px;
    line-height: 1;
    font-size: 0.75em;
    font-family: 'Roboto Mono', monospace;
}

#performanceDebug {
    position: absolute;
    top: 30px;
    right: 225px;
    line-height: 1;
    font-size: 0.75em;
    text-align: right;
    font-family: 'Roboto Mono', monospace;
}

#gameScoreContainer {
    position: absolute;
    display: flex;
    flex-direction: column;
    align-items: flex-end;
    top: 25px;
    right: 25px;
}

#gameScore {
    font-size: 2em;
    font-weight: 900;
    line-height: 1;
    font-family: 'Roboto Mono', monospace;
}

@keyframes streakCountPulse {
    from {
        scale: 1.25;
    }
}

#streakContainer {
    display: flex;
    gap: 10px;
    align-items: center;
}

#streakCount {
    font-weight: 700;
}

#streakBar {
    width: 150px;
    height: 10px;
    border: 2px solid white;
    background-color: black;
}

@keyframes streakBarScared {
  from {
    translate: 0px -2px;
  }
  to {
    translate: 0px 2px;
  }
}

#innerStreakBar {
    height: 100%;
    width: 50%;
    background-color: white;
    transition: width linear 20ms;
}

#gameStyleContainer {
    display: flex;
    flex-direction: column-reverse;
    justify-content: flex-end;
    width: 250px;
    height: 250px;
    mask-image: linear-gradient(to top, rgba(0, 0, 0, 0), 35%, rgba(0, 0, 0, 1));
}

.gameStyle {
    display: flex;
    justify-content: space-between;
    align-items: center;
    gap: 5px;
    white-space: nowrap;
    line-height: 1;
    min-height: 20px;
    animation: gameStyleIn 250ms ease-in-out 1 forwards;
}

@keyframes gameStyleIn {
    from {
        min-height: 0;
        height: 0;
        opacity: 0;
    }
    to {
        min-height: 20px;
        height: 20px;
    }
}

#gameRunInfo {
    position: absolute;
    bottom: 25px;
    right: 25px;
    display: flex;
    flex-direction: column;
    align-items: end;
    line-height: 1;
}

#gameWaveCounter {
    font-size: 2em;
    font-weight: 700;
    transform-origin: 100% 100%;
    scale: 1;
    line-height: 0.7;
}

@keyframes wavePulse {
    from {
        scale: 2;
    }
}

#gameWaveBar {
    width: 100px;
    height: 4px;
    overflow: hidden;
    box-shadow: inset 0px 0px 0px 1px rgb(255,255,255,0.25);
}

#gameInnerWaveBar {
    height: 100%;
    width: 50%;
    background-color: white;
}

#area {
    width: 500px;
    height: 500px;
    outline: 2px solid white;
    background-color: black;
    cursor: none;
    position: relative;
    transition: box-shadow ease-in-out 1s, scale ease-in-out 500ms;
}

#areaCanvasTop, #areaCanvasBottom {
    position: absolute;
    top: 0;
    left: 0;
}

#player {
    width: 36px;
    height: 36px;
    position: absolute;
    z-index: 3;
    display: flex;
    justify-content: center;
    align-items: center;
    transition: scale ease-in-out 500ms;
}

#playerTextureContainer {
    overflow: hidden;
    height: 100%;
    width: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    position: absolute;
    pointer-events: none;
}

#playerTextureContainer img {
    translate: 0px 0px;
    height: 74px;
    align-self: self-start;
    position: absolute;
}

.playerCosmeticContainer {
    position: absolute;
    height: 144px;
    width: 144px;
    overflow: hidden;
    pointer-events: none;
}

.playerCosmeticContainer img {
    height: 144px;
}

@keyframes playerHit {
    from {
        outline: 2px solid rgb(255,100,100);
    }
    to {
        outline: 2px solid transparent;
    }
}

#weapon {
    position: absolute;
    z-index: 4;
    pointer-events: none;
    translate: -50% -50%;
    transition: left linear 100ms, top linear 100ms, scale ease-in-out 500ms;
}

#meleeHitbox {
    width: 75px;
    height: 75px;
    outline: 1px solid rgb(255,255,255,0.25);
    position: absolute;
    translate: -50% -50%;
    overflow: hidden;
    transition: left linear 100ms, top linear 100ms;
}

@keyframes meleeHitboxHit {
    from {
        background-color: rgb(255,255,255,0.5);
    }
}

#innerMeleeHitbox {
    width: 100%;
    height: 100%;
    background-color: rgb(255,255,255,0.25);
}

#grazeHitbox {
    position: absolute;
    outline: 1px solid transparent;
    translate: -50% -50%;
}

@keyframes grazeHitboxFlash {
    from {
        outline: 1px solid rgb(255,255,255,0.25);
    }
    to {
        outline: 1px solid transparent;
    }
}

#sandboxEnemy {
    position: absolute;
    aspect-ratio: 1 / 1;
    translate: -50% -50%;
    border-radius: 5px;
}

.projectile {
    z-index: 1;
    display: flex;
    justify-content: center;
    align-items: center;
    position: absolute;
    transition: left linear 20ms, top linear 20ms;
    translate: -50% -50%;
}


@keyframes enemyIn {
    from {
        scale: 0;
    }
}

@keyframes enemyWait {
    from {
        opacity: 0.35;
    }
    50% {
        opacity: 0.25;
    }
    to {
        opacity: 0.35;
    }
}

@keyframes enemyInit {
    from {
        outline: 3px solid white;
    }
    to {
        outline: 0px solid transparent;
    }
}

@keyframes enemyHit {
    from {
        box-shadow: inset 0px 0px 0px 2px rgb(255,100,100);
        scale: 0.95 1.05;
    }
    50% {
        scale: 1.05 0.95;
    }
    to {
        box-shadow: inset 0px 0px 0px 2px transparent;
        scale: 1 1;
    }
}

@keyframes projectileIn {
    from {
        scale: 0;
    }
}

.enemyHealthBarContainer {
    width: 100%;
    position: absolute;
    opacity: 0;
    display: flex;
    align-items: center;
    top: -25px;
}

.enemyHealthBar {
    width: 100%;
    height: 5px;
    background-color: black;
    border: 2px solid white;
}

.enemyLevel {
    height: 12px;
    background-color: black;
    display: flex;
    justify-content: center;
    align-items: center;
    outline: 2px solid white;
    font-size: 0.75em;
    font-weight: 700;
    white-space: nowrap;
    padding: 0px 2px;
}

.innerEnemyHealthBar {
    background-color: red;
    box-shadow: inset 0px 2.5px 0px rgb(255,255,255,0.5);
    height: 100%;
    width: 0%;
    transition: width cubic-bezier(0,1,.5,1) 500ms;
    animation: healthBarPulse 250ms ease-out 1 forwards;
}

@keyframes healthBarPulse {
    from {
        background-color: rgb(255,200,200);
    }
}

@keyframes explosion {
    to {
        opacity: 0;
        /* filter: blur(5px); */
    }
}

@keyframes magnetIn {
    from {
        transform: translateY(-25px);
        opacity: 0;
    }
}

@keyframes magnetExplosion {
    to {
        opacity: 0;
        filter: blur(25px);
    }
}

@keyframes explosionEffect {
    to {
        opacity: 0;
        scale: var(--explosionEffectScale);
    }
}

@keyframes coinHitEffect {
    to {
        scale: 10;
        opacity: 0;
    }
}

@keyframes pickupOut {
    to {
        scale: 0 2;
        filter: brightness(100);
    }
}

.poisonField {
    translate: -50% -50%;
    position: absolute;
    animation: poisonFieldIn 500ms cubic-bezier(0,1,.5,1) 1 forwards;
}

@keyframes poisonFieldIn {
    from {
        opacity: 0;
        scale: 0;
        outline-width: 25px;
        border-radius: 50%;
    }
    50% {
        opacity: 1;
    }
}

@keyframes popupMove {
    50% {
        opacity: 1;
        /* filter: drop-shadow(0px 0px 5px black) blur(0px); */
    }
    to {
        translate: var(--popupX) var(--popupY);
        opacity: 0;
        /* filter: drop-shadow(0px 0px 5px black) blur(5px); */
    }
}

.particle {
    position: absolute;
    border-radius: 50%;
    translate: -50% -50%;
    transform-origin: center;
    z-index: 15;
    animation: particle var(--particleDuration) var(--particleTimingFunction) 1 forwards;
}

@keyframes particle {
    to {
        translate: var(--particleX) var(--particleY);
        scale: 0;
    }
}

@keyframes parryEffect {
    to {
        scale: 100;
        opacity: 0;
    }
}

.portal {
    width: 50px;
    height: 50px;
    border: 1px solid white;
    position: absolute;
    translate: -50% -50%;
    background-color: black;
    z-index: 2;
    animation: portalIn 500ms ease-out 1 forwards;
    transition: width ease-in-out 1s, height ease-in-out 1s, border ease-in 1s;
}

.portal div {
    position: absolute;
    width: 100%;
    height: 100%;
}

.portal div:nth-child(1) {
    background-image: url(graphics/starsbig.png);
    animation: portalStars 10s linear infinite forwards;
}

.portal div:nth-child(2) {
    background-image: url(graphics/starssmall.png);
    animation: portalStars 15s linear infinite forwards;
}

@keyframes portalIn {
    from {
        scale: 0;
    }
}

@keyframes portalStars {
    to {
        background-position: 256px 256px;
    }
}

.portalEffect {
    width: 50px;
    height: 50px;
    box-shadow: inset 0px 0px 10px rgb(255,255,255,0.25);
    translate: -50% -50%;
    position: absolute;
    animation: portalEffect 1s ease-out 1 forwards;
}

@keyframes portalEffect {
    to {
        scale: 10;
        opacity: 0;
    }
}

@keyframes electricityChain {
    to {
        opacity: 0;
    }
}